//import
import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.RadioButton;
import javafx.scene.control.Label;
import javafx.scene.control.PasswordField; 
import javafx.scene.control.ComboBox;
import javafx.scene.control.ToggleGroup;
import javafx.scene.control.TextField;
import javafx.scene.layout.HBox;
import javafx.scene.paint.Color;
import javafx.scene.text.Font;
import javafx.scene.text.FontWeight;
import javafx.scene.text.Text;
import javafx.stage.Stage;
import javafx.scene.Group;

public class Dekomposisi extends Stage{
	public Dekomposisi(Stage dekomposisi){
	
		dekomposisi.setTitle("TUBES METNUM"); //judul
		Group root = new Group();
		
		// membuat text
		Text scenetitle = new Text("METODE DEKOMPOSISI-SEGITIGA");
		scenetitle.setFont(Font.font("Tahoma", FontWeight.NORMAL, 20));
		scenetitle.setLayoutX(200);//posisi x
		scenetitle.setLayoutY(30);//posisi y
		root.getChildren().add(scenetitle);
		
		//membuat label dan text field
		Label awal = new Label("Masukkan matriks 3 x 3");
		awal.setLayoutX(50);
		awal.setLayoutY(50);
		root.getChildren().add(awal);
		
		TextField xj1 = new TextField();
		xj1.setLayoutX(50);
		xj1.setLayoutY(85);
		root.getChildren().add(xj1);
		
		TextField yj1 = new TextField();
		yj1.setLayoutX(200);
		yj1.setLayoutY(85);
		root.getChildren().add(yj1);
		
		TextField zj1 = new TextField();
		zj1.setLayoutX(350);
		zj1.setLayoutY(85);
		root.getChildren().add(zj1);
		
		TextField bj1 = new TextField();
		bj1.setLayoutX(500);
		bj1.setLayoutY(85);
		root.getChildren().add(bj1);
		
		TextField xj2 = new TextField();
		xj2.setLayoutX(50);
		xj2.setLayoutY(120);
		root.getChildren().add(xj2);
		
		TextField yj2 = new TextField();
		yj2.setLayoutX(200);
		yj2.setLayoutY(120);
		root.getChildren().add(yj2);
		
		TextField zj2 = new TextField();
		zj2.setLayoutX(350);
		zj2.setLayoutY(120);
		root.getChildren().add(zj2);
		
		TextField bj2 = new TextField();
		bj2.setLayoutX(500);
		bj2.setLayoutY(120);
		root.getChildren().add(bj2);
		
		TextField xj3 = new TextField();
		xj3.setLayoutX(50);
		xj3.setLayoutY(155);
		root.getChildren().add(xj3);
		
		TextField yj3 = new TextField();
		yj3.setLayoutX(200);
		yj3.setLayoutY(155);
		root.getChildren().add(yj3);
		
		TextField zj3 = new TextField();
		zj3.setLayoutX(350);
		zj3.setLayoutY(155);
		root.getChildren().add(zj3);
		
		TextField bj3 = new TextField();
		bj3.setLayoutX(500);
		bj3.setLayoutY(155);
		root.getChildren().add(bj3);
		
		
		//membuat button
		Button bHasil = new Button();
		bHasil.setLayoutX(50);
		bHasil.setLayoutY(210);
		bHasil.setText("hasil");
		root.getChildren().add(bHasil);
		
		//label untuk hasil
		TextField x1 = new TextField();
		x1.setLayoutX(200);
		x1.setLayoutY(210);
		root.getChildren().add(x1);
		
		TextField x2 = new TextField();
		x2.setLayoutX(350);
		x2.setLayoutY(210);
		root.getChildren().add(x2);
		
		TextField x3 = new TextField();
		x3.setLayoutX(500);
		x3.setLayoutY(210);
		root.getChildren().add(x3);
		
		Scene scene = new Scene(root, 700, 300);
		scene.setFill(Color.web("#12eaf8")); //memberi warna scene
		dekomposisi.setScene(scene);
		// setScene(scene);
		
		Button balik = new Button("kembali");
		balik.setOnAction(new EventHandler<ActionEvent>() {
			@Override
			public void handle(ActionEvent e){
				Stage A = new MenuUtama(dekomposisi);
			}
		});
		root.getChildren().add(balik);
		
		bHasil.setOnAction(new EventHandler<ActionEvent>(){
		@Override
		public void handle(ActionEvent e){
		
			double[][] a = new double[10][11];
			double t,det=1;
			
			String tamp;
			
			tamp = xj1.getText();
			a[0][0] = Double.parseDouble(tamp);
			tamp = yj1.getText();
			a[0][1] = Double.parseDouble(tamp);
			tamp = zj1.getText();
			a[0][2] = Double.parseDouble(tamp);
			tamp = bj1.getText();
			a[0][3]= Double.parseDouble(tamp);
			
			tamp = xj2.getText();
			a[1][0] = Double.parseDouble(tamp);
			tamp = yj2.getText();
			a[1][1] = Double.parseDouble(tamp);
			tamp = zj2.getText();
			a[1][2] = Double.parseDouble(tamp);
			tamp = bj2.getText();
			a[1][3] = Double.parseDouble(tamp);
			
			tamp = xj3.getText();
			a[2][0] = Double.parseDouble(tamp);
			tamp = yj3.getText();
			a[2][1] = Double.parseDouble(tamp);
			tamp = zj3.getText();
			a[2][2] = Double.parseDouble(tamp);
			tamp = bj3.getText();
			a[2][3] = Double.parseDouble(tamp);
			
			
			/* PROSES */
			int i,j,k,N=3;
			for(i=0;i<N;i++){
				for(j=0;j<N;j++){  
					if(i!=j){  
						t=a[j][i]/a[i][i];  
							for(k=0;k<N+1;k++){ 
								a[j][k]-=a[i][k]*t;
							}
					}
				}
			}
			for(i=0;i<N;i++){  
				det=a[i][i];
			}

			double[] x = new double[3];
		
			if(det==0){
				System.out.println("hash");
			}else{
				for(i=0;i<N;i++){
					x[i] = a[i][N]/a[i][i];  
				}
				
			}
			
			x1.setText("" + x[0]);
			x2.setText("" + x[1]);
			x3.setText("" + x[2]);
			
			}
		});

}
}