import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.control.Label;
import javafx.scene.control.Button;
import javafx.scene.control.TextField;
import javafx.scene.layout.GridPane;
import javafx.scene.text.Text;
import javafx.scene.text.Font;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import java.lang.*;
import java.io.*;
import javafx.scene.layout.VBox;
import javafx.scene.paint.Color;

class NewtonRhapson extends Stage{
	int a = 0;
	public NewtonRhapson(Stage menu){
		menu.setTitle("NewtonRhapson");
		Group root = new Group();

		Scene scene = new Scene(root, 350, 300);
		scene.setFill(Color.web("#12eaf8")); //memberi warna scene
		menu.setScene(scene);
		// setScene(scene);
		
		GridPane gridpane = new GridPane();
		gridpane.setHgap(5);
        gridpane.setVgap(2);
		
		Text judul = new Text("METODE NEWTON-RHAPSON");
		judul.setLayoutX(45);
		judul.setLayoutY(50);	
		judul.setFont(Font.font(null,20));
		
		VBox vbox = new VBox();
			vbox.setSpacing(5); 
			vbox.setLayoutY(70); 
			vbox.setLayoutX(50); 
			vbox.getChildren().addAll(gridpane); 
		root.getChildren().addAll(judul, vbox);

		
		Label fx = new Label("f(x):");
		gridpane.add(fx, 0, 1);
		
		Label x1 = new Label("Xo:");
		gridpane.add(x1, 0, 2);
		
		TextField tFx = new TextField();
		gridpane.add(tFx, 1, 1);
		
		TextField tX1 = new TextField();
		gridpane.add(tX1, 1, 2);
		
		Button bhitung = new Button("Hitung");
		gridpane.add(bhitung, 0, 5);
		
		TextField tX2asil = new TextField();
		gridpane.add(tX2asil, 1, 5);
		
		Button balik = new Button("kembali");
		balik.setOnAction(new EventHandler<ActionEvent>() {
			@Override
			public void handle(ActionEvent e){
				Stage A = new MenuUtama(menu);
			}
		});
		root.getChildren().add(balik);
		
		bhitung.setOnAction(new EventHandler<ActionEvent>() {
			@Override
			public void handle(ActionEvent event){
				cekinput cek = new cekinput();
				cek.cekmasukan(tFx.getText());
								
				double pangter = cek.getpangter();
				
				if(pangter==2.0){
					fungsipersamaan a = new fungsipersamaan(cek.getkon1(),cek.getkon2(),cek.getpang1(),cek.getpang2(),cek.getkon3());
					a.newtonrhapson(Integer.parseInt(tX1.getText()));
					tX2asil.setText(""+a.getNRH());
				}
				else if(pangter==3.0){
					fungsipersamaan a = new fungsipersamaan(cek.getkon1(),cek.getkon2(),cek.getkon3(),cek.getpang1(),cek.getpang2(),cek.getpang3(),cek.getkon4());
	
					a.newtonrhapson(Integer.parseInt(tX1.getText()));
					tX2asil.setText(""+a.getNRH());
				}
				else if(pangter==4.0){
					fungsipersamaan a = new fungsipersamaan(cek.getkon1(),cek.getkon2(),cek.getkon3(),cek.getkon4(),cek.getpang1(),cek.getpang2(),cek.getpang3(),cek.getpang4(),cek.getkon5());
					
					a.newtonrhapson(Integer.parseInt(tX1.getText()));
					tX2asil.setText(""+a.getNRH());
				}
			}
        });
		
	}
}

