import java.lang.Math;

class fungsipersamaan{
	double koef1;
	double koef2;
	double koef3;
	double koef4;
	double koef5;
	double pangkat1;
	double pangkat2;
	double pangkat3;
	double pangkat4;
	double pangkat5;
	double konstanta;
	
	double x;
	double epsilon;
	double akar;
	
	fungsipersamaan(){
	}
	
	fungsipersamaan(double koef1baru,double koef2baru,double pangkat1,double pangkat2, double konstanta){
		this.koef1 = koef1baru;		
		this.koef2 = koef2baru;		
		this.pangkat1 = pangkat1;		
		this.pangkat2 = pangkat2;		
		this.konstanta = konstanta;		
		this.epsilon = 0.001;
	}
	fungsipersamaan(double koef1baru,double koef2baru,double koef3baru,double pangkat1,double pangkat2,double pangkat3, double konstanta){
		this.koef1 = koef1baru;		
		this.koef2 = koef2baru;		
		this.koef3 = koef2baru;		
		this.pangkat1 = pangkat1;		
		this.pangkat2 = pangkat2;		
		this.pangkat3 = pangkat3;		
		this.konstanta = konstanta;		
		this.epsilon = 0.001;
	}
	fungsipersamaan(double koef1baru,double koef2baru,double koef3baru,double koef4baru,double pangkat1,double pangkat2,double pangkat3,double pangkat4, double konstanta){
		this.koef1 = koef1baru;		
		this.koef2 = koef2baru;		
		this.koef3 = koef2baru;		
		this.koef4 = koef2baru;		
		this.pangkat1 = pangkat1;		
		this.pangkat2 = pangkat2;		
		this.pangkat3 = pangkat3;		
		this.pangkat4 = pangkat4;		
		this.konstanta = konstanta;		
		this.epsilon = 0.001;
	}
	
	private double f(double x){
		return ((this.koef1*Math.pow(x,this.pangkat1)) + (this.koef2*Math.pow(x,this.pangkat2)) + (this.koef3*Math.pow(x,this.pangkat3)) + (this.koef4*Math.pow(x,this.pangkat4)) + this.konstanta);
	}
	private double fAksen(double x){
		return (((this.koef1*this.pangkat1)*Math.pow(x,this.pangkat1-1)) + ((this.koef2*this.pangkat2)*Math.pow(x,this.pangkat2-1)) + ((this.koef3*this.pangkat3)*Math.pow(x,this.pangkat3-1)) + ((koef4*pangkat4)*Math.pow(x,this.pangkat4-1)) + this.konstanta);
	}
	private double g1(double x){
		return Math.pow(-konstanta/(this.koef4*Math.pow(x,this.pangkat4-this.pangkat1))+(this.koef3*Math.pow(x,this.pangkat3-this.pangkat1))+(this.koef2*Math.pow(x,this.pangkat2-this.pangkat1))+(this.koef1),1/this.pangkat1);
	}
	private double g2(double x){
		return Math.pow
		(-konstanta/(this.koef1*Math.pow(x,this.pangkat1-this.pangkat2))+(this.koef4*Math.pow(x,this.pangkat4-this.pangkat2))+(this.koef3*Math.pow(x,this.pangkat3-this.pangkat2))+(this.koef2),1/this.pangkat2);
	}
	private double g3(double x){
		return Math.pow
		(-konstanta/(this.koef2*Math.pow(x,this.pangkat2-this.pangkat3))+(this.koef1*Math.pow(x,this.pangkat1-this.pangkat3))+(this.koef4*Math.pow(x,this.pangkat4-this.pangkat3))+(this.koef3),1/this.pangkat3);
	}
	private double g4(double x){
		return Math.pow
		(-konstanta/(this.koef3*Math.pow(x,this.pangkat3-this.pangkat4))+(this.koef2*Math.pow(x,this.pangkat2-this.pangkat4))+(this.koef1*Math.pow(x,this.pangkat1-this.pangkat4))+(this.koef4),1/this.pangkat4);
	}
	
	double BGD = 0;
	void bagidua(double a,double b){
		int status=0;
		double c;
		do{
			c = (a+b)/2;
			if(f(a) * f(c) < 0 ){
				b = c;
			}else{
				a = c;
			}
			status++;
		}while(((Math.abs(a-b))>this.epsilon)&&(status<50));
		BGD = c;
		
		// if(status<50){	
			// System.out.println("nilai akar : "+akar);
		// }else{
			// System.out.println("terjadi eror disebabkan nilai akar terus naik atau terjadi pembagian dengan nol");
		// }
	}
	
	double getBagiDua(){
		return BGD;
	}
	
	double PSPL=0;
	void posisipalsu(double a,double b){
		double c;
		int status=0;
		do{
			c = b-((f(b) * (b-a))/f(b) - f(a));
			if(Math.abs(f(c))<epsilon){
				a=c;
				b=c;
			}else{
				if(f(a)*f(b)<0){
					b=c;
				}else{
					a=c;
				}
			}
			status++;
		}while(((Math.abs(a-b)>this.epsilon)&&(status<50)));
	
		PSPL = c;
		// if(status<50){	
			// System.out.println("nilai akar : "+akar);
		// }else{
			// System.out.println("terjadi eror disebabkan nilai akar terus naik atau terjadi pembagian dengan nol");
		// }
	}
	
	double getPSPL(){
		return PSPL;
	}
	
	double NRH=0;
	void newtonrhapson(double a){
		double aSebelumnya;
		int status=0;
		do{
			aSebelumnya = a;
			
			a = a-(f(a)/fAksen(a));
			// System.out.println(a);
			status++;
			// System.out.println(a);
		}while((Math.abs(a - aSebelumnya)>this.epsilon)&&(status<50));
	
		NRH = a;
		// if(status<50){	
			// System.out.println("nilai akar : "+akar);
		// }else{
			// System.out.println("terjadi eror disebabkan nilai akar terus naik atau terjadi pembagian dengan nol");
		// }
	}
	
	double getNRH(){
		return NRH;
	}
	
	double TTP=0;
	void titiktetap(double a){
		double aSebelumnya;
		int status=0;
		do{
			aSebelumnya = a;
			
				if((pangkat1<pangkat2)&&(pangkat1<pangkat3)&&(pangkat1<pangkat4)){
					if(pangkat1!=0){
						a = g1(a);
					}else{
						if((pangkat2<pangkat3)&&(pangkat2<pangkat4)){
							a = g2(a);
						}else if((pangkat3<pangkat4)&&(pangkat3<pangkat2)){
							a = g3(a);
						}else if((pangkat4<pangkat3)&&(pangkat4<pangkat2)){
							a = g4(a);
						}
					}
				}else if((pangkat2<pangkat1)&&(pangkat2<pangkat3)&&(pangkat2<pangkat4)){
					if(pangkat2!=0){
						a = g2(a);
					}else{
						if((pangkat1<pangkat3)&&(pangkat1<pangkat4)){
							a = g1(a);
						}else if((pangkat3<pangkat4)&&(pangkat3<pangkat1)){
							a = g3(a);
						}else if((pangkat4<pangkat3)&&(pangkat4<pangkat1)){
							a = g4(a);
						}
					}
				}else if((pangkat3<pangkat1)&&(pangkat3<pangkat2)&&(pangkat3<pangkat4)){
					if(pangkat3!=0){
						a = g3(a);
					}else{
						if((pangkat1<pangkat2)&&(pangkat1<pangkat4)){
							a = g1(a);
						}else if((pangkat2<pangkat4)&&(pangkat2<pangkat1)){
							a = g2(a);
						}else if((pangkat4<pangkat2)&&(pangkat4<pangkat1)){
							a = g4(a);
						}
					}
				}else if((pangkat4<pangkat1)&&(pangkat4<pangkat2)&&(pangkat4<pangkat3)){
					if(pangkat4!=0){
						a = g4(a);
					}else{
						if((pangkat1<pangkat2)&&(pangkat1<pangkat3)){
							a = g1(a);
						}else if((pangkat2<pangkat3)&&(pangkat2<pangkat1)){
							a = g2(a);
						}else if((pangkat3<pangkat2)&&(pangkat3<pangkat1)){
							a = g3(a);
						}
					}
				}
			
		status++;
		}while((Math.abs(a - aSebelumnya)>this.epsilon)&&(status<50));
		
		TTP = a;
	}
	double getTTP(){
		return TTP;
	}
}
