//import
import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.RadioButton;
import javafx.scene.control.Label;
import javafx.scene.control.PasswordField; 
import javafx.scene.control.ComboBox;
import javafx.scene.control.ToggleGroup;
import javafx.scene.control.TextField;
import javafx.scene.layout.HBox;
import javafx.scene.paint.Color;
import javafx.scene.text.Font;
import javafx.scene.text.FontWeight;
import javafx.scene.text.Text;
import javafx.stage.Stage;
import javafx.scene.Group;

// import Galat;

public class MenuUtama extends Stage{
	
	public static boolean status;
	public static boolean status1;
	public Galat g = new Galat();
	
	public MenuUtama(Stage primaryStage) {
		primaryStage.setTitle("TUBES METNUM"); //judul
		Group root = new Group();
		
		Scene scene = new Scene(root, 310, 570);
		primaryStage.setScene(scene);
		primaryStage.show();
		
		//membuat button
		Button satu = new Button();
		satu.setLayoutX(110);
		satu.setLayoutY(10);
		satu.setText("GALAT MUTLAK");
		root.getChildren().add(satu);
		
		Button dua = new Button();
		dua.setLayoutX(113);
		dua.setLayoutY(45);
		dua.setText("GALAT RELATIF");
		root.getChildren().add(dua);
			
		Button tiga = new Button();
		tiga.setLayoutX(100);
		tiga.setLayoutY(80);
		tiga.setText("METODE BAGI DUA");
		root.getChildren().add(tiga);
		
		Button empat = new Button();
		empat.setLayoutX(90);
		empat.setLayoutY(115);
		empat.setText("METODE POSISI PALSU");
		root.getChildren().add(empat);
		
		Button lima = new Button();
		lima.setLayoutX(93);
		lima.setLayoutY(150);
		lima.setText("METODE TITIK TETAP");
		root.getChildren().add(lima);
		
		Button enam = new Button();
		enam.setLayoutX(75);
		enam.setLayoutY(185);
		enam.setText("METODE NEWTON-RHAPSON");
		root.getChildren().add(enam);
		
		Button tujuh = new Button();
		tujuh.setLayoutX(110);
		tujuh.setLayoutY(220);
		tujuh.setText("METODE GAUSS");
		root.getChildren().add(tujuh);
		
		Button delapan = new Button();
		delapan.setLayoutX(78);
		delapan.setLayoutY(255);
		delapan.setText("METODE GAUSS-JORDAN");
		root.getChildren().add(delapan);
		
		Button sembilan = new Button();
		sembilan.setLayoutX(60);
		sembilan.setLayoutY(290);
		sembilan.setText("METODE DEKOMPOSISI SEGITIGA");
		root.getChildren().add(sembilan);
		
		Button sepuluh = new Button();
		sepuluh.setLayoutX(20);
		sepuluh.setLayoutY(325);
		sepuluh.setText("INTERPOLASI BEDA MAJU NEWTON-RHAPSON");
		root.getChildren().add(sepuluh);
		
		Button sebelas = new Button();
		sebelas.setLayoutX(12);
		sebelas.setLayoutY(360);
		sebelas.setText("INTERPOLASI BEDA MUNDUR NEWTON-RHAPSON");
		root.getChildren().add(sebelas);
		
		Button duabelas = new Button();
		duabelas.setLayoutX(15);
		duabelas.setLayoutY(395);
		duabelas.setText("INTERPOLASI BEDA TERBAGI NEWTON-RHAPSON");
		root.getChildren().add(duabelas);
		
		Button tigabelas = new Button();
		tigabelas.setLayoutX(75);
		tigabelas.setLayoutY(430);
		tigabelas.setText("INTERPOLASI LANGRANGE");
		root.getChildren().add(tigabelas);
		
		Button empatbelas = new Button();
		empatbelas.setLayoutX(90);
		empatbelas.setLayoutY(465);
		empatbelas.setText("KAIDAH TRAPESIUM");
		root.getChildren().add(empatbelas);
		
		Button limabelas = new Button();
		limabelas.setLayoutX(87);
		limabelas.setLayoutY(500);
		limabelas.setText("KAIDAH TITIK TENGAH");
		root.getChildren().add(limabelas);
		
		Button enambelas = new Button();
		enambelas.setLayoutX(88);
		enambelas.setLayoutY(535);
		enambelas.setText("KAIDAH SIMPSON 1/3");
		root.getChildren().add(enambelas);
		
		// Button tujuhbelas = new Button();
		// tujuhbelas.setLayoutX(82);
		// tujuhbelas.setLayoutY(570);
		// tujuhbelas.setText("KUADRAN GAUSS 2 TITIK");
		// root.getChildren().add(tujuhbelas);
		
		// Button delapanbelas = new Button();
		// delapanbelas.setLayoutX(82);
		// delapanbelas.setLayoutY(605);
		// delapanbelas.setText("KUADRAN GAUSS 3 TITIK");
		// root.getChildren().add(delapanbelas);
		
		// Button sembilanbelas = new Button();
		// sembilanbelas.setLayoutX(140);
		// sembilanbelas.setLayoutY(640);
		// sembilanbelas.setText("EXIT");
		// root.getChildren().add(sembilanbelas);
		
		
		
		satu.setOnAction(new EventHandler<ActionEvent>(){
		@Override
		public void handle(ActionEvent e) {
			Stage satu = new GalatMutlak(primaryStage);
			// satu.show();
		}
		});
		
		dua.setOnAction(new EventHandler<ActionEvent>(){
		@Override
		public void handle(ActionEvent e) {
			Stage dua = new GalatRelatif(primaryStage);
			// dua.show();
		
		}
		});
		
		tiga.setOnAction(new EventHandler<ActionEvent>(){
		@Override
		public void handle(ActionEvent e) {
			Stage BagiDua = new BagiDua(primaryStage);
		}
		});
		
		empat.setOnAction(new EventHandler<ActionEvent>(){
		@Override
		public void handle(ActionEvent e) {
		
			Stage PosisiPalsu = new PosisiPalsu(primaryStage);
		
		}
		});
		
		lima.setOnAction(new EventHandler<ActionEvent>(){
		@Override
		public void handle(ActionEvent e) {
			
			Stage TitikTetap = new TitikTetap(primaryStage);
		
		}
		});
		
		enam.setOnAction(new EventHandler<ActionEvent>(){
		@Override
		public void handle(ActionEvent e) {
		
			Stage NewtonRhapson = new NewtonRhapson(primaryStage);
		
		}
		});
		
		tujuh.setOnAction(new EventHandler<ActionEvent>(){
		@Override
		public void handle(ActionEvent e) {
			Stage tujuh = new Gauss(primaryStage);
			// tujuh.show();
		
		}
		});
		
		delapan.setOnAction(new EventHandler<ActionEvent>(){
		@Override
		public void handle(ActionEvent e) {
			Stage delapan = new GaussJordan(primaryStage);
			// delapan.show();
		
		}
		});

			
		sembilan.setOnAction(new EventHandler<ActionEvent>(){
		@Override
		public void handle(ActionEvent e) {
			Stage sembilan = new Dekomposisi(primaryStage);
			// sembilan.show();
		}
		});
		
		sepuluh.setOnAction(new EventHandler<ActionEvent>(){
		@Override
		public void handle(ActionEvent e) {
			Stage sepuluh = new BedaMaju(primaryStage);
			// sepuluh.show();
		}
		});
		
		sebelas.setOnAction(new EventHandler<ActionEvent>(){
		@Override
		public void handle(ActionEvent e) {
			Stage sebelas = new BedaMundur(primaryStage);
			// sebelas.show();
		}
		});
		
		duabelas.setOnAction(new EventHandler<ActionEvent>(){
		@Override
		public void handle(ActionEvent e) {
			Stage duabelas = new BedaTerbagi(primaryStage);
			// duabelas.show();
		}
		});
		
		tigabelas.setOnAction(new EventHandler<ActionEvent>(){
		@Override
		public void handle(ActionEvent e) {
			Stage tigabelas = new Langrange(primaryStage);
			// tigabelas.show();
		}
		});
		
		empatbelas.setOnAction(new EventHandler<ActionEvent>(){
		@Override
		public void handle(ActionEvent e) {
			Stage empatbelas = new StageTrapesium(primaryStage);
			// empatbelas.show();
		}
		});
		
		limabelas.setOnAction(new EventHandler<ActionEvent>() {
			@Override
			public void handle(ActionEvent e){
				Stage StageTitikTengah = new StageTitikTengah(primaryStage);
				// StageTitikTengah.show();
			}
		});
		
		enambelas.setOnAction(new EventHandler<ActionEvent>(){
		@Override
		public void handle(ActionEvent e) {
			Stage enambelas = new StageSimpson(primaryStage);
			// enambelas.show();
		}
		});
		
		// tujuhbelas.setOnAction(new EventHandler<ActionEvent>(){
		// @Override
		// public void handle(ActionEvent e) {
			// Stage tujuhbelas = new Dekomposisi(primaryStage);
			// tujuhbelas.show();
		// }
		// });
		
		// delapanbelas.setOnAction(new EventHandler<ActionEvent>(){
		// @Override
		// public void handle(ActionEvent e) {
			// Stage delapanbelas = new Dekomposisi(primaryStage);
			// delapanbelas.show();
		// }
		// });
		
		
	}
}