import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.control.Label;
import javafx.scene.control.Button;
import javafx.scene.control.TextField;
import javafx.scene.layout.GridPane;
import javafx.scene.text.Text;
import javafx.scene.text.Font;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import java.lang.*;
import java.io.*;
import javafx.scene.paint.Color;

class StageTrapesium extends Stage{
	int y = 11; //buat koordinat y gridpane
	public StageTrapesium(Stage menu){
		menu.setTitle("Trapesium");
		Group root = new Group();

		Scene scene = new Scene(root, 300, 280);
		scene.setFill(Color.web("#12eaf8")); //memberi warna scene
		menu.setScene(scene);
		// setScene(scene);
		
		GridPane gridpane = new GridPane();
		root.getChildren().add(gridpane);
		gridpane.setHgap(20);
        gridpane.setVgap(15);
		
		Text judul = new Text("Kaidah Trapesium");
		judul.setLayoutX(50);
		judul.setLayoutY(46);
		judul.setFont(Font.font(null,20));
		root.getChildren().add(judul);
		
		Label lba = new Label("Batas atas:");
		gridpane.add(lba, 1, 5);
		
		Label lbb = new Label("Batas bawah:");
		gridpane.add(lbb, 1, 6);
		
		Label lh = new Label("Nilai h:");
		gridpane.add(lh, 1, 7);
		
		Label ln = new Label("Nilai n:");
		gridpane.add(ln, 1, 8);
		
		TextField tba = new TextField("0");
		gridpane.add(tba, 2, 5);
		
		TextField tbb = new TextField("0");
		gridpane.add(tbb, 2, 6);
		
		TextField th = new TextField("0");
		gridpane.add(th, 2, 7);
		
		TextField tn = new TextField("0");
		gridpane.add(tn, 2, 8);
		
		Button bhitung = new Button("Hasil");
		gridpane.add(bhitung, 1, 9);
		
		TextField thasil = new TextField();
		gridpane.add(thasil, 2, 9);
		
		Text fi[] = new Text[20];
		for (int i=0;i<20;i++){
			fi[i] = new Text();
			gridpane.add(fi[i], 1, y);
			y++;
		}
		
		y = 11;
		
		TextField fiIsi[] = new TextField[20];
		for (int i=0;i<20;i++){
			fiIsi[i] = new TextField();
			fiIsi[i].setVisible(false);
			gridpane.add(fiIsi[i], 2, y);
			y++;
		}
		
		Button balik = new Button("kembali");
		balik.setOnAction(new EventHandler<ActionEvent>() {
			@Override
			public void handle(ActionEvent e){
				Stage A = new MenuUtama(menu);
			}
		});
		root.getChildren().add(balik);
		
		bhitung.setOnAction(new EventHandler<ActionEvent>() {
			@Override
			public void handle(ActionEvent event){
				float a = Float.parseFloat(tba.getText());
				float b = Float.parseFloat(tbb.getText());
				float h = Float.parseFloat(th.getText());
				float n = Float.parseFloat(tn.getText());
				
				if (h==0){
					h = (b-a)/n;
				}else if (n==0){
					n = (int)Math.round((b-a)/h); //Math.round() -> convert float to int (dibulatkan)
				}
				
				float f;
				float[] x = new float[20];
				double e = 2.71828;
				x[0] = a;
				float sum = 0;
				
				for (int i=0;i<=n;i++){
					f = (float)Math.pow(e, x[i]);
					x[i+1] = x[i] + h;
					fi[i].setText("f("+String.format("%.2f",x[i])+") = ");
					fiIsi[i].setText(""+f);
					fiIsi[i].setVisible(true);
					// System.out.printf("f(%.1f) = %f\n",x[i], f);
					if (i==0 || i==n){
						sum = sum + f;
					}else{ //dikali 2 yang sekain pertama dan terakhir
						sum = sum + (2*f);
					}
				}
				
				float hasil = h / 2 * sum;
				thasil.setText(""+hasil);
				menu.setHeight(600);
			}
        });
		
	}
}

